### dating functions used for historic NEP data

import datetime


def parse_date(date_string):
    """parse date depending on format"""
    if len(date_string) == 10:
        return datetime.datetime.strptime(date_string, "%Y-%m-%d")
    return datetime.datetime.strptime(date_string, "%Y-%m-%dT%H:%M:%SZ")


def is_it_a_close_date(d_1, d_2, limit=86400):
    t_1 = parse_date(d_1)
    t_2 = parse_date(d_2)
    diff = abs((t_1 - t_2).seconds)
    if diff < limit:
        return True
    return False
