"""date utilities"""

from datetime import datetime

TF = '%Y-%m-%dT%H:%M:%SZ'
YMD = '%Y-%m-%d'

def to_epoch(string):
    if len(string) == 10:
        parsed = datetime.strptime(string, YMD)
    else:
        parsed = datetime.strptime(string, TF)
    count = int(parsed.strftime("%s"))
    return count

def parse_date(string):
    """parse date depending on format"""
    if len(string) == 10:
        return datetime.strptime(string, YMD)
    return datetime.strptime(string, TF)

def is_it_a_close_date(d_1, d_2, limit=86400):
    t_1 = parse_date(d_1)
    t_2 = parse_date(d_2)
    diff = abs((t_1 - t_2).seconds)
    if diff < limit:
        return True
    return False

def diff_days(d_1, d_2):
    t_1 = parse_date(d_1)
    t_2 = parse_date(d_2)
    diff_days = abs((t_1 - t_2).days)
    return diff_days
